﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		D.K（あるふぁ～秘密基地）										*/
/*	製作開始	2008/05/22														*/
/*	MAIL		dk@red.interq.or.jp												*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2008/05/22	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出

		EXIT,
	};
	
	struct POS
	{
		int x;
		int y;
	}
	struct CHARCTAR
	{
		int life;
		int timer;
		POS pos;
		POS vec;
		int size;
		int type;

		int muteki;

		int spd;
		int dir;

		int shottimer;
		int shotsize;
		int enelgy_geteffect;

		int move[10];

		POS zanzou[120];
		int enelgy;
	}
	int zanzou_max = 120;

    enum COLLSION_TYPE
    {
        EN_COLTYPE_NONE = 0,
        EN_COLTYPE_PLAYER,
        EN_COLTYPE_PLAYER_BOM,
        EN_COLTYPE_ENEMY,
        EN_COLTYPE_MAP,
        EN_COLTYPE_ITEM,
    }  ;
	struct COLLISION
	{
	    int life;		//存在の有無
	    int coltype;	//コリジョンタイプ
	    int index;		//関連してるキャラクターのインデックス
	    POS pos;		//位置   キャラクターの中央からのオフセット
	    POS size;		//サイズ
	    int hitparam;	//判定の種類
	    int damege;		//相手へのダメージ
	}

    int COLLISION_MAX = (800);
    COLLISION collision[800];


	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count;			// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int game_score = 0;				//スコア
	int hi_score[4];				//ハイスコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int menu_input = 0;				//敵を倒したときのWAITカウンタ
	int mode = 0;					//ゲームモード

	int ENELGY_MAX = 10000;			//エネルギー最大
	int ITEM_MAX = 20;				//アイテム個数
	int MAP_MAX = 1200;				//アイテム個数
	int ENEMY_MAX = 20;				//アイテム個数
	int EFFECT_MAX = 200;				//アイテム個数
	
	CHARCTAR player;
	CHARCTAR map[1200];
	CHARCTAR item[20];
	CHARCTAR enemy[20];
	CHARCTAR effect[200];
	
	int DOT = 100;					//固定少数
	int speed = 100;				//スクロール速度
	int clear_kyori = 100;			//クリアになる距離
	int kyori_10m = 100;

	int shake_pow = 0;
	int shake_x = 0;
	int shake_y = 0;
	int hitstop_count = 0;
	int softwait_count = 0;
	int intcnt = 0;

	int replaymode;			//リプレイモード
	int debug_disp = 0;
	
	Keypad keypad;					// キーボード/ゲームパッド取得用
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("tama","resource/image/tama.bmp" , [0,255,0]);

		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		Hell_loadWAV("itemget",         "resource/sound/itemget.wav");
		Hell_loadWAV("miss",            "resource/sound/miss.wav");
		Hell_loadWAV("break",           "resource/sound/break.wav");
		Hell_loadWAV("up",              "resource/sound/up.wav");
		Hell_loadWAV("bariya",          "resource/sound/bariya.wav");

		
		//セーブデータ
		savedata = new ConfigParser();
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE1",         0);
			savedata.set("HI_SCORE2",         0);
			savedata.set("HI_SCORE3",         0);
			savedata.set("HI_SCORE4",         0);
			savedata.set("MODE",         1);
			savedata.write();
		}
		hi_score[0] = savedata.getint("HI_SCORE1");
		hi_score[1] = savedata.getint("HI_SCORE2");
		hi_score[2] = savedata.getint("HI_SCORE3");
		hi_score[3] = savedata.getint("HI_SCORE4");
		mode = savedata.getint("MODE");

		switch( mode )
		{
			case 0:
				clear_kyori = 100;
				Hell_randSeed( 733, 17 );
				break;
			case 1:
				clear_kyori = 200;
				Hell_randSeed( 1252, 14 );
				break;
			case 2:
				clear_kyori = 300;
				Hell_randSeed( 144, 1 );
				break;
			case 3:
				clear_kyori = 0;
				Hell_randSeed( 658, 256 );
				break;
			default:
				break;
		}

		game_time_count = 0;		//ゲーム終了までの残り時間
		game_score = 0;
		speed = 100;					//スクロール速度

		shake_pow = 0;
		shake_x = 0;
		shake_y = 0;
		hitstop_count = 0;
		softwait_count = 0;
		intcnt = 0;

		player_create( 0, 100 * DOT, 240 * DOT );

		map_init( );

Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;

		replaymode = Hell_GetGameflag( 0 );	//リプレイモード
		if ( replaymode != 0 )
		{
			//リプレイを再生する
			try
			{
				char[] str = std.string.format( "replay/replay_%02d.bin", mode );
				keypad.load( str );
			}
			catch(Exception e)
			{
				//ファイルのオープンに失敗した
				iSceneStatus = SCENE.EXIT;
			}
		}

	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		shake_set( 0 );
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		if ( stage_start_count < ( 60 * 3 ) )
		{
			stage_start_count++;
		}
		else 
		{
			Hell_playBgm( "resource/sound/bgm.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
			stage_start_count = 0;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if ( stage_start_count > ( 60 * 2 ) )
		{
			Hell_drawFont(" GO! " , 240, 200 , 4 , 255,255,255);
		}
		else
		{
			Hell_drawFont("READY" , 240, 200 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if ( ( keypad.isPushEnter(true) ) || ( keypad.isPushUp(true) ) )
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);
//		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);

		Hell_drawFont( "RESULTS" , 200, 250 , 4 , 255,255,255);

		str = std.string.format( "%d", game_score );

		Hell_drawFont( "SCORE" ,    210, 300 , 2 , 255,255,255);
		Hell_drawFont( str , 220, 320 , 4 , 255,255,255);
		if ( hi_score[mode] <= game_score )
		{
			int r = 255;
			int g = 255;
			int b = 255;
			if ( ( intcnt % 2 ) == 0 )
			{
				r = Hell_randInt(0, 255);
				g = Hell_randInt(0, 255);
				b = Hell_randInt(0, 255);
			}
			Hell_drawFont( "NEW RECORD !",170, 390 , 4 , r,g,b);
		}

		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PURESS Z OR UP BUTTON TO EXIT" , 100, 200 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont(" OWARI !" , 200, 420 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
        move_delete_collision();
		
		if ( hitstop_count == 0 )
		{
			if ( ( ( intcnt % 2 ) == 0 ) && ( softwait_count > 0 ) )
			{
			}
			else
			{
				switch( iSceneStatus )
				{
				case SCENE.INIT:
					//初期化
					init( );
					break;
				case SCENE.START:
					//開始
					SeneStart_move( );
					break;
				case SCENE.MAIN:
					keypad.update( );	//リプレイキー入力の更新
					//メイン
					player_move( );
					map_move( );
					item_move( );
					enemy_move( );
					effect_move( );
					system_move( );
		            move_collision();

					break;
				case SCENE.CLEAR:
					//クリア
		//			effect_move( );
		//			mob_move( );
					player_move( );
					map_move( );
					item_move( );
					enemy_move( );
					effect_move( );

					SeneClear_move( );
					break;
				case SCENE.END:
					//ゲームオーバー
					break;
				case SCENE.PAUSE:
					//一時停止
					break;
				case SCENE.RELESE:
					//後処理
					relese( );
					break;

				case SCENE.EXIT:
				default:
					//シーンの終了
					setMsg(GameState.MSG_REQ_TITLE);
					break;
				}
			}
		}
	
		if ( iSceneStatus != SCENE.PAUSE )
		{
			shake_move( );
			softwait_move( );
			hitstop_move( );
		}
		else
		{
			//一時停止
			Hell_drawOffset( 0, 0 );
			pause_move( );
		}
		
		intcnt++;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			enemy_draw( );
			map_draw( );
			effect_draw( 0 );
			player_draw( );
			item_draw( );
			effect_draw( 1 );
			system_draw( );

			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			enemy_draw( );
			map_draw( );
			effect_draw( 0 );
			player_draw( );
			item_draw( );
			effect_draw( 1 );
			system_draw( );

            draw_collision();
			break;
		case SCENE.CLEAR:
			//クリア
			enemy_draw( );
			map_draw( );
			effect_draw( 0 );
//			player_draw( );
			item_draw( );
			effect_draw( 1 );
			system_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			enemy_draw( );
			map_draw( );
			effect_draw( 0 );
			player_draw( );
			item_draw( );
			effect_draw( 1 );
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			enemy_draw( );
			map_draw( );
			effect_draw( 0 );
			player_draw( );
			item_draw( );
			effect_draw( 1 );
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		//残り時間のカウント
		game_time_count += speed;
		game_score++;
		

		int susumu = ( game_time_count / DOT ) / kyori_10m;
		if ( clear_kyori == 0 )
		{
			susumu = -1;
		}
		if ( ( player.life <= 0 ) || ( susumu >= clear_kyori ) )
		{
			speed = 0;					//スクロール速度
			
			Hell_playBgm( "resource/sound/results.wav", 0, 0 );

			if ( replaymode == 0 )
			{
				//ハイスコアの保存
				if ( hi_score[mode] < game_score )
				{
					char[] str = std.string.format( "replay/replay_%02d.bin", mode );
					keypad.save( str );	//リプレイの保存
					hi_score[mode] = game_score;
					savedata.set("HI_SCORE1",   cast(int)hi_score[0]);
					savedata.set("HI_SCORE2",   cast(int)hi_score[1]);
					savedata.set("HI_SCORE3",   cast(int)hi_score[2]);
					savedata.set("HI_SCORE4",   cast(int)hi_score[3]);
					savedata.write();
				}
			}

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		
		//距離
		
		{
			int i;
			int susumu = ( game_time_count + ( -100 * DOT ) ) / DOT;
			for ( i = -100; i <= 740; i++ )
			if ( ( ( i + susumu ) % kyori_10m ) == 0 )
			{
				if ( ( i + susumu ) >= 0 )
				{
					if ( ( ( ( i + susumu ) / kyori_10m ) <= clear_kyori ) || ( clear_kyori == 0 ) )
					{
						str = std.string.format( "%d0m", ( i + susumu ) / kyori_10m );
						Hell_drawFont( str , i, 460 , 2 , 255,255,255);
					}
				}
			} 
		}
		
		//エネルギー
		int enelgy_x = 170;
		int enelgy_y = 20;
		Hell_drawFont( "ENELGY" , enelgy_x-100, enelgy_y - 2 , 2 , 255,255,255);
		Hell_drawRect( enelgy_x - 2, enelgy_y - 2, 300 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);
		Hell_drawRect( enelgy_x, enelgy_y, 300, 10, 0, 0, 255, 0, 0, 255);
		
		int haba = ( player.enelgy * 300 ) / ENELGY_MAX;
		if ( haba > 0 )
		{
			Hell_drawRect( enelgy_x, enelgy_y, haba, 10, 0, 0, 251, 231, 49, 255);
		}

		//スコア
		str = std.string.format( "SCORE:%d", game_score );
		Hell_drawFont( str , 2, 2 , 2 , 255,255,255);

		//ハイスコア
		str = std.string.format( "HI:%d", hi_score[mode] );
		Hell_drawFont( str , 300, 2 , 2 , 255,255,255);

	
	}
	
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
//			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
//			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	//-----------------------------------------------------------------------------
	//	プレイヤーの生成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void player_create( int type, int x, int y )
	{
		player.life = 1;
		player.type = type;
		player.pos.x = x;
		player.pos.y = y;
		player.enelgy = ENELGY_MAX;
		player.size = 8 * DOT;
		player.shottimer = 0;
		player.shotsize = 80 * DOT;
		player.muteki= 0;

		int i;
		for ( i = ( zanzou_max - 1 ); i >= 0; i-- )
		{
			player.zanzou[i].x = -20000;
			player.zanzou[i].y = -20000;
		}
	}
	//-----------------------------------------------------------------------------
	//	プレイヤーの移動
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	int USEBOMB_ENELGY = 2000;
	void player_move( )
	{
		if ( player.life == 0 )
		{
			return;
		}
		
		if(keypad.isPressUp(false))
		{
			if ( player.enelgy > 0 )
			{
				player.vec.y = player.vec.y + 200;
				effect_create( 1, player.pos.x, player.pos.y, Hell_randInt(-64, 64), Hell_randInt(1000, 2000), 0, 0 );
				if(keypad.isPushUp(false))
				{
					Hell_playWAV( "up", 0, -1 );
				}
			}
		}
		else if(keypad.isPressDown(false))
		{
		}
		
		player.shottimer--;
		if ( player.shottimer < 0 )
		{
			player.shottimer = 0;
		}
		if(keypad.isPushEnter(false))
		{
			if ( ( player.enelgy > USEBOMB_ENELGY ) && ( player.shottimer == 0 ) )
			{
				player.enelgy -= USEBOMB_ENELGY;
				player.shottimer = 60 * 10;
				Hell_playWAV( "bariya", 0, -1 );
			}
		}
		
		//重力
		player.vec.y = player.vec.y - 98;
		player.pos.y = player.pos.y - ( player.vec.y / 10 );
		
		//エネルギー
		player.enelgy -= 3;
		if ( player.enelgy < 0 )
		{
			player.enelgy = 0;
		}
		
		
		player.enelgy_geteffect--;
		if ( player.enelgy_geteffect < 0 )
		{
			player.enelgy_geteffect = 0;
		}
		if ( player.enelgy_geteffect > 0 )
		{
			int i;
			for ( i = 0; i < 4; i++ )
			{
				int dx = player.pos.x;
				int dy = player.pos.y;
//				int size = player.size / 2 / DOT;

				int vx;
				int vy;
				int spd = player.enelgy_geteffect * 8 * DOT;
				speed_vec( ( i * 256 ) + ( intcnt * 32 ), spd, &vx, &vy );

//				Hell_setAlpha(HELL_ALPHA_NORMAL);
//				Hell_drawRectEx( dx + vx, dy + vy, size, size, 0, 0, 0xff, 0xff, 0xff, 0xff );
				effect_create( 3, dx + vx, dy + vy, 0, 0, 0, 0 );
			}
		}

		//無敵判定
		player.muteki--;
		if ( player.muteki < 0 )
		{
			player.muteki = 0;
		}

		//画面外判定
		if ( player.pos.y < -0 * DOT )
		{
			player.pos.y = -0 * DOT;
			player.vec.y = 0;
			player.life--;
		}
		if ( player.pos.y > 480 * DOT )
		{
			player.pos.y = 480 * DOT;
			player.vec.y = 0;
			player.life--;
		}
		
		if ( player.life <= 0 )
		{
			player_death( );
			player.life = 0;
		}
		
		
		//残像
		int i;
		for ( i = ( zanzou_max - 1 ); i > 0; i-- )
		{
			player.zanzou[i].x = player.pos.x - ( speed * i );
			player.zanzou[i].y = player.zanzou[i - 1].y;
		}
		player.zanzou[0].x = player.pos.x;
		player.zanzou[0].y = player.pos.y;
		
	    set_collision( COLLSION_TYPE.EN_COLTYPE_PLAYER, 0, player.pos.x, player.pos.y, player.size, player.size, 0, 1 );
		
		if ( player.shottimer > 0 )
		{
		    set_collision( COLLSION_TYPE.EN_COLTYPE_PLAYER_BOM, 0, player.pos.x, player.pos.y, player.shotsize, player.shotsize, 0, 1 );
		}
		
		game_score++; 
		
		player.timer++;
	}
    void SetplayerDamege(COLLISION my, COLLISION you)
    {
        CHARCTAR* mychar = GetCollisionType_to_CharctarBuffer(my.coltype, my.index);
        CHARCTAR* youchar = GetCollisionType_to_CharctarBuffer(you.coltype, you.index);
        int player_num = my.index;
        int damege = you.damege;

		if ( player.muteki == 0 )        
		{
	        switch ( you.coltype )
	        {
				case COLLSION_TYPE.EN_COLTYPE_ENEMY:
				case COLLSION_TYPE.EN_COLTYPE_MAP:
	                player.enelgy -= ( ENELGY_MAX / 2 );
	                if ( player.enelgy < 0 )
	                {
						player.enelgy = 0;
					}
	        		player.muteki= 60 * 3;
					break;
				default:
					break;
			}
			player_death( );
			if ( player.life <= 0 )
			{
				player.life = 0;
			}
			Hell_playWAV( "miss", 0, -1 );
		}

    }
    void player_death(  )
    {
		{
			int i;
			for ( i = 0; i < 100; i++ )
			{
				effect_create( 1, player.pos.x, player.pos.y, Hell_randInt(0, 1024), Hell_randInt(1000, 2000), 0, 0 );
			}
			shake_set( 30 );
			softwait_set( 30 );
		}
	}
    
	//-----------------------------------------------------------------------------
	//	プレイヤーの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void player_draw( )
	{
		if ( player.life <= 0 )
		{
			return;
		}
		if ( ( player.muteki > 0 ) && ( ( player.muteki % 4 ) < 2 ) )
		{
			return;
		}
		
		{
			//残像表示
			int i;
			for ( i = ( zanzou_max - 1 ); i > 0; i-- )
			{
				int dx = player.zanzou[i].x / DOT;
				int dy = player.zanzou[i].y / DOT;
				int size = player.size / 2 / DOT;

				Hell_setAlpha(HELL_ALPHA_NORMAL);
				Hell_drawRectEx( dx, dy, size, size, 0, 0, 0x40, 0x40, 0xff, 0xff );
			}
		}
		{
			//プレイヤー本体
			int dx = player.pos.x / DOT;
			int dy = player.pos.y / DOT;
			int size = player.size / 2 / DOT;

			Hell_setAlpha(HELL_ALPHA_NORMAL);
			Hell_drawRectEx( dx, dy, size, size, 0, 0, 0xa0, 0xa0, 0xff, 0xff );
		}
		
		//ボム
		if ( player.shottimer > 0 )
		{
			int dx = player.pos.x / DOT;
			int dy = player.pos.y / DOT;
			int size = ( player.shotsize / 2 ) / DOT;

			Hell_setAlpha(HELL_ALPHA_NORMAL);
//			Hell_drawRectEx( dx, dy, size, size, 0, 0, 0xa0, 0xa0, 0xff, 0xff );
			Hell_drawCircle( dx, dy, cast( float )size , 0, 0xa0, 0xa0, 0xff, 0x80);
		}

	}

	//-----------------------------------------------------------------------------
	//	マップの生成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void map_create( int type, int x, int y )
	{
		int i;
		for ( i = 0 ; i < MAP_MAX; i++ )
		{
			if ( map[i].life <= 0 )
			{
				map[i].life = 1;
				map[i].type = type;
				map[i].pos.x = x;
				map[i].pos.y = y;
				map[i].size = 16 * DOT;
				break;
			}
		}
		
	}
	//-----------------------------------------------------------------------------
	//	マップの移動
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	int map_timer = 0;
	int map_create_int = 0;
	int map_create_int2 = 0;
	int map_kankaku = 0;
	int map_haba = 0;
	int map_sentaku = 0;
	void map_init( )
	{
		map_timer = 0;
		map_create_int = 0;
		map_kankaku = 0;
		map_haba = 0;
		map_sentaku = 1;
	}
	void map_move( )
	{
		//地形の自動生成
		
		if ( ( map_create_int2 / 2 ) == map_create_int )
		{
			if ( map_create_int2 > 0 )
			{
				item_create( 0, 670 * DOT, ( Hell_randInt(1, 28) * 16 ) * DOT );
			}
		}
		
		map_create_int--;
		if ( map_create_int <= 0 )
		{
			switch( map_kankaku )
			{
				case 0:
					map_create_int = Hell_randInt(140, 200);
					break;
				case 1:
					map_create_int = Hell_randInt(120, 160);
					break;
				case 2:
					map_create_int = Hell_randInt(100, 120);
					break;
				case 3:
					map_create_int = Hell_randInt(80, 100);
					break;
				default:
					break;
			}
			map_create_int2 = map_create_int;
			
			//地形生成
			int i;

			int ana_haba[10];
			int ana_start[10];
			for ( i = 0; i < map_sentaku; i++ )
			{
				ana_start[i] = Hell_randInt(1, 28);
				switch( map_haba )
				{
					case 0:
						ana_haba[i] = Hell_randInt(8, 12);
						break;
					case 1:
						ana_haba[i] = Hell_randInt(6, 10);
						break;
					case 2:
						ana_haba[i] = Hell_randInt(4, 6);
						break;
					case 3:
						ana_haba[i] = Hell_randInt(2, 3);
						break;
					default:
						ana_start[i] = -10;
						ana_haba[i] = 0;
						break;
				}
				if ( i == 1 )
				{
					if ( Hell_randInt(0, 2) == 0 )
					{
						int y = ana_start[i] + ( ana_haba[i] / 2 );
						enemy_create( Hell_randInt(0, 3), 670 * DOT, 16 * y * DOT );
					}
				}
			}
			
			for ( i = 0; i < 40; i++ )
			{
				int j;
				bool haiti = true;
				for ( j = 0; j < 10; j++ )
				{
					if (
					     ( ana_start[j] <= i )
					  && ( ( ana_start[j] + ana_haba[j] ) > i ) 
					   )
					{
						haiti = false;
					}
				}
				if ( haiti == true )
				{
					map_create( 0, 670 * DOT, 16 * i * DOT );
				}
			}
			
			
		}
		
		map_timer++;
		if ( map_timer > ( 60 * 3 ) )
		{
			map_timer = 0;
			
			map_kankaku = Hell_randInt(0, 3);
			map_haba = Hell_randInt(0, 3);
			map_sentaku = Hell_randInt(1, 4);
		}

		
		//地形の移動
		int i;
		for ( i = 0 ; i < MAP_MAX; i++ )
		{
			if ( map[i].life > 0 )
			{
				map[i].pos.x -= speed;
				
				if ( map[i].pos.x < ( -50 * DOT ) )
				{
					map[i].life = 0;
				}
				
			    set_collision( COLLSION_TYPE.EN_COLTYPE_MAP, i, map[i].pos.x, map[i].pos.y, map[i].size, map[i].size, 0, 1 );

				map[i].timer++;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	マップの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void map_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		//壁
		int i;
		for ( i = 0 ; i < MAP_MAX; i++ )
		{
			if ( map[i].life > 0 )
			{
				int dx = map[i].pos.x / DOT;
				int dy = map[i].pos.y / DOT;
				int size = map[i].size / 2 / DOT;

				Hell_setAlpha(HELL_ALPHA_NORMAL);
				Hell_drawRectEx( dx, dy, size, size, 0, 0, 0x40, 0xff, 0x40, 0xff );
			}
		}
	}
	
	//-----------------------------------------------------------------------------
	//	アイテムの生成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void item_create( int type, int x, int y )
	{
		int i;
		for ( i = 0 ; i < ITEM_MAX; i++ )
		{
			if ( item[i].life <= 0 )
			{
				item[i].life = 1;
				item[i].type = type;
				item[i].pos.x = x;
				item[i].pos.y = y;
				item[i].size = 20 * DOT;
				break;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	アイテムの移動
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void item_move( )
	{
		int i;
		for ( i = 0 ; i < ITEM_MAX; i++ )
		{
			if ( item[i].life > 0 )
			{
				item[i].pos.x -= speed;
				
				if ( item[i].pos.x < ( -50 * DOT ) )
				{
					item[i].life = 0;
				}
				
			    set_collision( COLLSION_TYPE.EN_COLTYPE_ITEM, i, item[i].pos.x, item[i].pos.y, item[i].size, item[i].size, 0, 1 );

				item[i].timer++;
			}
		}
	}
    void SetItemDamege(COLLISION my, COLLISION you)
    {
        CHARCTAR* mychar = GetCollisionType_to_CharctarBuffer(my.coltype, my.index);
        CHARCTAR* youchar = GetCollisionType_to_CharctarBuffer(you.coltype, you.index);

		mychar.life -= 1;

		youchar.enelgy += 1000;
		if ( youchar.enelgy > ENELGY_MAX )
		{
			youchar.enelgy = ENELGY_MAX;
		}
		
		Hell_playWAV( "itemget", 0, -1 );

		youchar.enelgy_geteffect = 20;
		
		int ten = 100;
		game_score += ten; 
		effect_create( 2, youchar.pos.x , youchar.pos.y, 512, 200, ten, 0 );

    }
	//-----------------------------------------------------------------------------
	//	アイテムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void item_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);

		int i;
		for ( i = 0 ; i < ITEM_MAX; i++ )
		{
			if ( item[i].life > 0 )
			{
				int dx = item[i].pos.x / DOT;
				int dy = item[i].pos.y / DOT;
				int size = item[i].size / 2 / DOT;

				Hell_setAlpha(HELL_ALPHA_NORMAL);
				Hell_drawRectEx( dx, dy, size, size, 0, 0, 243, 213, 26, 0xff );
			}
		}
	}

	//-----------------------------------------------------------------------------
	//	敵の生成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void enemy_create( int type, int x, int y )
	{
		int i;
		for ( i = 0 ; i < ENEMY_MAX; i++ )
		{
			if ( enemy[i].life <= 0 )
			{
				enemy[i].life = 1;
				enemy[i].type = type;
				enemy[i].pos.x = x;
				enemy[i].pos.y = y;
				enemy[i].size = 20 * DOT;
				break;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	敵の移動
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void enemy_move( )
	{
		int i;
		for ( i = 0 ; i < ENEMY_MAX; i++ )
		{
			if ( enemy[i].life > 0 )
			{
				enemy[i].pos.x -= speed;
				
				if ( enemy[i].pos.x < ( -50 * DOT ) )
				{
					enemy[i].life = 0;
				}
				
				int size_y = enemy[i].size;
				if ( enemy[i].type == 0 )
				{
					size_y = enemy[i].size * 2;
				}
				if ( enemy[i].type == 1 )
				{
					size_y = enemy[i].size * 3;
				}
				if ( enemy[i].type == 2 )
				{
					size_y = enemy[i].size * 4;
				}
			    set_collision( COLLSION_TYPE.EN_COLTYPE_ENEMY, i, enemy[i].pos.x, enemy[i].pos.y, enemy[i].size, size_y, 0, 1 );

				enemy[i].timer++;
			}
		}
	}
    void SetEnemyDamege(COLLISION my, COLLISION you)
    {
        CHARCTAR* mychar = GetCollisionType_to_CharctarBuffer(my.coltype, my.index);
        CHARCTAR* youchar = GetCollisionType_to_CharctarBuffer(you.coltype, you.index);
        
        switch ( you.coltype )
        {
			case COLLSION_TYPE.EN_COLTYPE_PLAYER_BOM:
		        mychar.life--;
				break;
			default:
				break;
		}
		if ( mychar.life <= 0 )
		{
			int i;
			for ( i = 0; i < 100; i++ )
			{
				effect_create( 0, mychar.pos.x, mychar.pos.y, Hell_randInt(0, 512), Hell_randInt(1000, 2000), 0, 0 );
			}
			
			int ten = 1000;
    		game_score += ten; 
			effect_create( 2, mychar.pos.x , mychar.pos.y, 512, 200, ten, 0 );
			shake_set( 20 );
//			softwait_set( 10 );

			Hell_playWAV( "break", 0, -1 );
		}

    }
	//-----------------------------------------------------------------------------
	//	敵の描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void enemy_draw( )
	{
		int i;
		for ( i = 0 ; i < ENEMY_MAX; i++ )
		{
			if ( enemy[i].life > 0 )
			{
				int dx = enemy[i].pos.x / DOT;
				int dy = enemy[i].pos.y / DOT;
				int size = enemy[i].size / 2 / DOT;

				int size_y = enemy[i].size / 2 / DOT;
				if ( enemy[i].type == 0 )
				{
					size_y *= 2;
				}
				if ( enemy[i].type == 1 )
				{
					size_y *= 3;
				}
				if ( enemy[i].type == 2 )
				{
					size_y *= 4;
				}

				Hell_setAlpha(HELL_ALPHA_NORMAL);
				Hell_drawRectEx( dx, dy, size, size_y, 0, 0, 243, 0, 0, 0xff );
			}
		}
	}
	
	//-----------------------------------------------------------------------------
	//	エフェクトの生成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void effect_create( int type, int x, int y, int dir, int spd, int param1, int param2 )
	{
		int i;
		for ( i = 0 ; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].life <= 0 )
			{
				effect[i].timer = 0;
				effect[i].life = 1;
				effect[i].type = type;
				effect[i].pos.x = x;
				effect[i].pos.y = y;
				effect[i].spd = spd;
				effect[i].dir = dir;

				switch( effect[i].type )
				{
					case 0:
						effect[i].size = 4 * DOT;
						speed_vec( dir, spd, &effect[i].vec.x, &effect[i].vec.y );
						break;
					case 1:
						effect[i].size = 2 * DOT;
						speed_vec( dir, spd, &effect[i].vec.x, &effect[i].vec.y );
						break;
					case 2:
						speed_vec( dir, spd, &effect[i].vec.x, &effect[i].vec.y );
						effect[i].move[0] = param1;
						break;
					case 3:
						effect[i].size = 8 * DOT;
						speed_vec( dir, spd, &effect[i].vec.x, &effect[i].vec.y );
						break;
					default:
						break;
				}
				break;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	エフェクトの移動
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void effect_move( )
	{
		int i;
		for ( i = 0 ; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].life > 0 )
			{
				effect[i].pos.x -= speed;
				
				switch( effect[i].type )
				{
					case 0:
					case 1:
						effect[i].vec.y += ( 98 / 2 );
						break;
					case 2:
						if ( effect[i].timer > 60 )
						{
							effect[i].life = 0;
						}
						break;
					case 3:
						if ( effect[i].timer > 2 )
						{
							effect[i].life = 0;
						}
						break;
					default:
						break;
				}
				effect[i].pos.x += effect[i].vec.x;
				effect[i].pos.y += effect[i].vec.y;
				
				if (
				     ( effect[i].pos.x < ( -50 * DOT ) )
				  || ( effect[i].pos.x > ( 690 * DOT ) )
				  || ( effect[i].pos.y < ( -50 * DOT ) )
				  || ( effect[i].pos.y > ( 530 * DOT ) )
				   )
				{
					effect[i].life = 0;
				}
				
				
				effect[i].timer++;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	エフェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void effect_draw( int pri )
	{
		char[] str;
		
		int i;
		for ( i = 0 ; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].life > 0 )
			{
				int dx = effect[i].pos.x / DOT;
				int dy = effect[i].pos.y / DOT;
				int size = effect[i].size / 2 / DOT;

				Hell_setAlpha(HELL_ALPHA_NORMAL);
				switch( effect[i].type )
				{
					case 0:
						Hell_drawRectEx( dx, dy, size, size, 0, 0, 243, 0, 0, 0xff );
						break;
					case 1:
						Hell_drawRectEx( dx, dy, size, size, 0, 0, 0x80, 0x80, 0xff, 0xff );
						break;
					case 2:
						str = std.string.format( "%dpt", effect[i].move[0] );
						Hell_drawFont( str , dx, dy , 2 , 255,255,255);
						break;
					case 3:
						Hell_drawRectEx( dx, dy, size, size, 0, 0, 0xff, 0xff, 0xff, 0xff );
						break;
					default:
						break;
				}
			}
		}
	}

	
    //コリジョン
    void set_collision(int coltype, int index, int x, int y, int w, int h, int hitparam, int damege)
    {
        int i;

        for (i = 0; i < COLLISION_MAX; i++)
        {
            if (collision[i].life <= 0)
            {
                collision[i].life = 1;				//存在の有無
                collision[i].coltype = coltype;				//存在の有無
                collision[i].index = index;			//存在の有無
                collision[i].pos.x = x;				//位置   キャラクターの中央からのオフセット
                collision[i].pos.y = y;				//位置   キャラクターの中央からのオフセット
                collision[i].size.x = w;			//サイズ
                collision[i].size.y = h;			//サイズ
                collision[i].hitparam = hitparam;	//判定の種類
                collision[i].damege = damege;		//相手へのダメージ
                break;
            }
        }
    }
    void move_collision()
    {
        int i;

        for (i = 0; i < COLLISION_MAX; i++)
        {
            if (collision[i].life > 0)
            {
                int ch1_x1 = 0;
                int ch1_x2 = 0;
                int ch1_y1 = 0;
                int ch1_y2 = 0;

                int ch2_x1 = 0;
                int ch2_x2 = 0;
                int ch2_y1 = 0;
                int ch2_y2 = 0;

//                    if ((GetIntCnt() % 2) == 0)
                {
/*
                    //自機ショットと敵
                    if (collision[i].coltype == COLLSION_TYPE.EN_COLTYPE_PLAYER_SHOT)
                    {
                        int j = 0;
                        for (j = 0; j < COLLISION_MAX; j++)
                        {

                            if ((collision[j].coltype == COLLSION_TYPE.EN_COLTYPE_ENEMY) && (collision[j].life > 0))
                            {
//                                if (collision[j].hitparam == COLLSION_TYPE.EN_HITPARAM_TI)
                                {
                                    ch1_x1 = collision[i].pos.x - (collision[i].size.x / 2);
                                    ch1_x2 = collision[i].pos.x + (collision[i].size.x / 2);
                                    ch1_y1 = collision[i].pos.y - (collision[i].size.y / 2);
                                    ch1_y2 = collision[i].pos.y + (collision[i].size.y / 2);

                                    ch2_x1 = collision[j].pos.x - (collision[j].size.x / 2);
                                    ch2_x2 = collision[j].pos.x + (collision[j].size.x / 2);
                                    ch2_y1 = collision[j].pos.y - (collision[j].size.y / 2);
                                    ch2_y2 = collision[j].pos.y + (collision[j].size.y / 2);

                                    //当たり判定
                                    if (
                                         (ch1_x1 <= ch2_x2)
                                      && (ch2_x1 <= ch1_x2)
                                      && (ch1_y1 <= ch2_y2)
                                      && (ch2_y1 <= ch1_y2)
                                       )
                                    {
                                        //ヒットコールバック
//                                        SetplyshotDamege(collision[i], collision[j]);
//                                        SetEnemyDamege(collision[j], collision[i]);
                                    }
                                }
                            }
                        }
                    }
*/                    
                }
                //ボムと敵
                if (collision[i].coltype == COLLSION_TYPE.EN_COLTYPE_PLAYER_BOM)
                {
                    int j = 0;
                    for (j = 0; j < COLLISION_MAX; j++)
                    {

                        if ((collision[j].coltype == COLLSION_TYPE.EN_COLTYPE_ENEMY) && (collision[j].life > 0))
                        {
//                            if (collision[j].hitparam == EN_HITPARAM_TI)
                            {
                                ch1_x1 = collision[i].pos.x - (collision[i].size.x / 2);
                                ch1_x2 = collision[i].pos.x + (collision[i].size.x / 2);
                                ch1_y1 = collision[i].pos.y - (collision[i].size.y / 2);
                                ch1_y2 = collision[i].pos.y + (collision[i].size.y / 2);

                                ch2_x1 = collision[j].pos.x - (collision[j].size.x / 2);
                                ch2_x2 = collision[j].pos.x + (collision[j].size.x / 2);
                                ch2_y1 = collision[j].pos.y - (collision[j].size.y / 2);
                                ch2_y2 = collision[j].pos.y + (collision[j].size.y / 2);

                                //当たり判定
                                if (
                                       (ch1_x1 <= ch2_x2)
                                    && (ch2_x1 <= ch1_x2)
                                    && (ch1_y1 <= ch2_y2)
                                    && (ch2_y1 <= ch1_y2)
                                    )
                                {
                                    //ヒットコールバック
//                                    SetplybomDamege(collision[i], collision[j]);
                                    SetEnemyDamege(collision[j], collision[i]);
                                }
                            }
                        }
                    }
                }
                
                {
                    //自機と敵
                    if (collision[i].coltype == COLLSION_TYPE.EN_COLTYPE_PLAYER)
                    {
                        int j = 0;
                        for (j = 0; j < COLLISION_MAX; j++)
                        {

                            if ((collision[j].coltype == COLLSION_TYPE.EN_COLTYPE_ENEMY) && (collision[j].life > 0))
                            {
//                                if (collision[j].hitparam == EN_HITPARAM_KU)
                                {
                                    ch1_x1 = collision[i].pos.x - (collision[i].size.x / 2);
                                    ch1_x2 = collision[i].pos.x + (collision[i].size.x / 2);
                                    ch1_y1 = collision[i].pos.y - (collision[i].size.y / 2);
                                    ch1_y2 = collision[i].pos.y + (collision[i].size.y / 2);

                                    ch2_x1 = collision[j].pos.x - (collision[j].size.x / 2);
                                    ch2_x2 = collision[j].pos.x + (collision[j].size.x / 2);
                                    ch2_y1 = collision[j].pos.y - (collision[j].size.y / 2);
                                    ch2_y2 = collision[j].pos.y + (collision[j].size.y / 2);

                                    //当たり判定
                                    if (
                                         (ch1_x1 <= ch2_x2)
                                      && (ch2_x1 <= ch1_x2)
                                      && (ch1_y1 <= ch2_y2)
                                      && (ch2_y1 <= ch1_y2)
                                       )
                                    {
                                        //ヒットコールバック
                                        SetplayerDamege(collision[i], collision[j]);
//                                        SetEnemyDamege(collision[j], collision[i]);
                                    }
                                }
                            }
                        }
                    }
                    //自機と地形
                    if (collision[i].coltype == COLLSION_TYPE.EN_COLTYPE_PLAYER)
                    {
                        int j = 0;
                        for (j = 0; j < COLLISION_MAX; j++)
                        {

                            if ((collision[j].coltype == COLLSION_TYPE.EN_COLTYPE_MAP) && (collision[j].life > 0))
                            {
//                                if (collision[j].hitparam == EN_HITPARAM_KU)
                                {
                                    ch1_x1 = collision[i].pos.x - (collision[i].size.x / 2);
                                    ch1_x2 = collision[i].pos.x + (collision[i].size.x / 2);
                                    ch1_y1 = collision[i].pos.y - (collision[i].size.y / 2);
                                    ch1_y2 = collision[i].pos.y + (collision[i].size.y / 2);

                                    ch2_x1 = collision[j].pos.x - (collision[j].size.x / 2);
                                    ch2_x2 = collision[j].pos.x + (collision[j].size.x / 2);
                                    ch2_y1 = collision[j].pos.y - (collision[j].size.y / 2);
                                    ch2_y2 = collision[j].pos.y + (collision[j].size.y / 2);

                                    //当たり判定
                                    if (
                                         (ch1_x1 <= ch2_x2)
                                      && (ch2_x1 <= ch1_x2)
                                      && (ch1_y1 <= ch2_y2)
                                      && (ch2_y1 <= ch1_y2)
                                       )
                                    {
                                        //ヒットコールバック
                                        SetplayerDamege(collision[i], collision[j]);
//                                        SetmapDamege(collision[j], collision[i]);
                                    }
                                }
                            }
                        }
                    }
                    
                    //アイテムと自機
                    if (collision[i].coltype == COLLSION_TYPE.EN_COLTYPE_ITEM)
                    {
                        int j = 0;
                        for (j = 0; j < COLLISION_MAX; j++)
                        {

                            if ((collision[j].coltype == COLLSION_TYPE.EN_COLTYPE_PLAYER) && (collision[j].life > 0))
                            {
                                ch1_x1 = collision[i].pos.x - (collision[i].size.x / 2);
                                ch1_x2 = collision[i].pos.x + (collision[i].size.x / 2);
                                ch1_y1 = collision[i].pos.y - (collision[i].size.y / 2);
                                ch1_y2 = collision[i].pos.y + (collision[i].size.y / 2);

                                ch2_x1 = collision[j].pos.x - (collision[j].size.x / 2);
                                ch2_x2 = collision[j].pos.x + (collision[j].size.x / 2);
                                ch2_y1 = collision[j].pos.y - (collision[j].size.y / 2);
                                ch2_y2 = collision[j].pos.y + (collision[j].size.y / 2);

                                //当たり判定
                                if (
                                     (ch1_x1 <= ch2_x2)
                                  && (ch2_x1 <= ch1_x2)
                                  && (ch1_y1 <= ch2_y2)
                                  && (ch2_y1 <= ch1_y2)
                                   )
                                {
                                    //ヒットコールバック
                                    SetItemDamege(collision[i], collision[j]);
//	        						SetplayerDamege( collision[j], collision[i] );	//アイテムはプレイヤー側でヒットを呼ばない
                                }
                            }
                        }
                    }
                    
                }
            }
        }
    }

    void move_delete_collision()
    {
        int i;

        for (i = 0; i < COLLISION_MAX; i++)
        {
            //コリジョン消去
            collision[i].life = 0;
        }
    }

    void draw_collision()
    {
        int i;
        int x;
        int y;

        if ( debug_disp == 0 )
        {
            return;
        }

        for (i = 0; i < COLLISION_MAX; i++)
        {
            if (collision[i].life > 0)
            {
//                if (g_DebugDisp != 0)
                {
                    int r = 255;
                    int g = 255;
                    int b = 255;
                    switch (collision[i].coltype)
                    {
                        case COLLSION_TYPE.EN_COLTYPE_PLAYER:
                            r = 255;
                            g = 0;
                            b = 0;
                            break;
                        case COLLSION_TYPE.EN_COLTYPE_PLAYER_BOM:
                            r = 128;
                            g = 0;
                            b = 128;
                            break;
                        case COLLSION_TYPE.EN_COLTYPE_ENEMY:
                            r = 0;
                            g = 0;
                            b = 128;
                            break;
                        case COLLSION_TYPE.EN_COLTYPE_MAP:
                            r = 0;
                            g = 128;
                            b = 128;
                            break;
                        case COLLSION_TYPE.EN_COLTYPE_ITEM:
                            r = 0;
                            g = 255;
                            b = 0;
                            break;
                        default:
                            break;
                    }
                    //中央
//                    ObjSetEx((int)CHAR_CODE.C_COL_02_P000_00_K, (int)SPBATCH_TYPE.EN_SPBACH_TYPE_05, collision[i].pos.x / DOT, collision[i].pos.y / DOT, 1.0f, 1.0f, 0, r, g, b, 255, 0.0f, GM_SPR_NONE, 0, -1, -1);
					Hell_setAlpha(HELL_ALPHA_NORMAL);
					int dx = collision[i].pos.x / DOT;
					int dy = collision[i].pos.y / DOT;
                    int sizex = collision[i].size.x / 2 / DOT;
                    int sizey = collision[i].size.y / 2 / DOT;
					Hell_drawRectEx( dx, dy, sizex, sizey, 2, 0, r, g, b, 0xff );


                    //左上
                    x = collision[i].pos.x - (collision[i].size.x / 2);
                    y = collision[i].pos.y - (collision[i].size.y / 2);
//                    ObjSetEx((int)CHAR_CODE.C_COL_01_P000_00_K, (int)SPBATCH_TYPE.EN_SPBACH_TYPE_05, x / DOT, y / DOT, 1.0f, 1.0f, 0, r, g, b, 255, 0.0f, GM_SPR_NONE, 0, -1, -1);

                    //右下
                    x = collision[i].pos.x + (collision[i].size.x / 2);
                    y = collision[i].pos.y + (collision[i].size.y / 2);
//                    ObjSetEx((int)CHAR_CODE.C_COL_01_P000_00_K + 2, (int)SPBATCH_TYPE.EN_SPBACH_TYPE_05, x / DOT, y / DOT, 1.0f, 1.0f, 0, r, g, b, 255, 0.0f, GM_SPR_NONE, 0, -1, -1);

                    //左下
                    x = collision[i].pos.x - (collision[i].size.x / 2);
                    y = collision[i].pos.y + (collision[i].size.y / 2);
//                    ObjSetEx((int)CHAR_CODE.C_COL_01_P000_00_K + 3, (int)SPBATCH_TYPE.EN_SPBACH_TYPE_05, x / DOT, y / DOT, 1.0f, 1.0f, 0, r, g, b, 255, 0.0f, GM_SPR_NONE, 0, -1, -1);

                    //右上
                    x = collision[i].pos.x + (collision[i].size.x / 2);
                    y = collision[i].pos.y - (collision[i].size.y / 2);
//                    ObjSetEx((int)CHAR_CODE.C_COL_01_P000_00_K + 1, (int)SPBATCH_TYPE.EN_SPBACH_TYPE_05, x / DOT, y / DOT, 1.0f, 1.0f, 0, r, g, b, 255, 0.0f, GM_SPR_NONE, 0, -1, -1);
                }
            }
        }
    }
    CHARCTAR* GetCollisionType_to_CharctarBuffer(int CollisionType, int index)
    {
        CHARCTAR* rc;

        switch (CollisionType)
        {
            case COLLSION_TYPE.EN_COLTYPE_PLAYER:
                rc = &player;
                break;
            case COLLSION_TYPE.EN_COLTYPE_PLAYER_BOM:
                break;
            case COLLSION_TYPE.EN_COLTYPE_ENEMY:
                rc = &enemy[index];
                break;
            case COLLSION_TYPE.EN_COLTYPE_MAP:
                rc = &map[index];
                break;
            case COLLSION_TYPE.EN_COLTYPE_ITEM:
                rc = &item[index];
                break;
            default:
                break;
        }

        return (rc);
    }

	void speed_vec( int dir, int spd, int* vx, int* vy )
	{
		float cdir = ( 360.0 * cast( float )dir )  / 1024.0;
		float x = Hell_sinEx( cdir ) * cast( float )spd;
		float y = Hell_cosEx( cdir ) * cast( float )spd;
		*vx = cast( int )x;
		*vy = cast( int )y;
	}

	void shake_set( int pow )
	{
		shake_pow = pow;
	}
	void shake_move( )
	{
		shake_pow--;
		if ( shake_pow < 0 )
		{
			shake_pow = 0;
		}
		else
		{
			shake_x = Hell_randInt(0, shake_pow) * 4;
			shake_y = Hell_randInt(0, shake_pow) * 4;
		}
		Hell_drawOffset( shake_x, shake_y );
		
	}
	void hitstop_set( int val )
	{
		hitstop_count = val;
	}
	void hitstop_move( )
	{
		hitstop_count--;
		if ( hitstop_count < 0 )
		{
			hitstop_count = 0;
		}
	}
	void softwait_set( int val )
	{
		softwait_count = val;
	}
	void softwait_move( )
	{
		softwait_count--;
		if ( softwait_count < 0 )
		{
			softwait_count = 0;
		}
	}
}


